#!/MUNGERPATH

; Copyright (c) 2001, 2002, 2003, James Bailie <jimmy@jamesbailie.com>.
; All rights reserved.
; 
; Redistribution and use in source and binary forms, with or without
; modification, are permitted provided that the following conditions are met:
; 
;     * Redistributions of source code must retain the above copyright
; notice, this list of conditions and the following disclaimer.
;     * Redistributions in binary form must reproduce the above copyright
; notice, this list of conditions and the following disclaimer in the
; documentation and/or other materials provided with the distribution.
;     * The name of James Bailie may not be used to endorse or promote 
; products derived from this software without specific prior written permission.
; 
; THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS "AS IS"
; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
; IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
; ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
; LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
; CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
; SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
; INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
; CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
; ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
; POSSIBILITY OF SUCH DAMAGE.

; This is a sample FastCGI script (http://www.fastcgi.com), intended to be
; invoked with the GET method.  It converts the x-www-form-urlencoded query
; string, and sends it back to the user with some of the other environment
; data set by the server.

; Make errors fatal.

(fatal)

; Load FCGI helper functions.

(load (join "/" (libdir) "fcgi.munger"))

(set 'send_page
   (lambda ()

      (get_data)

      (let ((query (cgi_getenv "QUERY_STRING"))
            (server (cgi_getenv "SERVER_NAME"))
            (port (cgi_getenv "SERVER_PORT"))
            (software (cgi_getenv "SERVER_SOFTWARE"))
            (protocol (cgi_getenv "SERVER_PROTOCOL"))
            (interface (cgi_getenv "GATEWAY_INTERFACE"))
            (agent (cgi_getenv "HTTP_USER_AGENT"))
            (addr (cgi_getenv "REMOTE_ADDR")))

         (send_headers "Sample FCGI Output" "" "")

         (cgi_print "<h1>Server:</h1><pre>")
         (cgi_newline)
         (cgi_print "Server Hostname:   " server "<br>")
         (cgi_newline)
         (cgi_print "Listening On Port: " port "<br>")
         (cgi_newline)
         (cgi_print "Running:           " software "<br>")
         (cgi_newline)
         (cgi_print "Using Protocol:    " protocol "<br>")
         (cgi_newline)
         (cgi_print "CGI Revision:      " interface "<p></pre>")
         (cgi_newline)

         (cgi_print "<h1>Client:</h1><pre>")
         (cgi_newline)
         (cgi_print "Client Address:    " addr "<br>")
         (cgi_newline)
         (cgi_print "Client Agent:      " agent "<p></pre>")
         (cgi_newline)

         (cgi_print "<h1>Query:</h1><pre>")
         (cgi_newline)

         (foreach (lambda (key)
                     (let ((val (lookup data key)))
                        (cgi_print "Query pair:        " key " = "
                           (if (eq "" val) "(not set)" val) "<br>")
                        (cgi_newline)))
                  (keys data))

         (cgi_print "</pre></body></html>")
         (cgi_newline))))

(while (cgi_accept)
   (send_page))

(exit 0)
