.Dd Wed, Aug 19 2004
.Dt httpf 1
.Sh NAME
.Nm httpf
.Nd Makes HTTP server appear to be UNIX filter
.Sh SYNOPSIS
.Nm httpf Ao hostname Ac Oo Ao port Ac Oc
.Sh DESCRIPTION
httpf is a filter which "wraps" a connection to an HTTP server.  With it, the
server can be treated like a filter itself.  The program allows shell programs
(and others lacking networking abilities) to submit HTTP requests to webs
servers on the filter's standard input, and get the servers' responses on the
filter's standard output.  The fetch(1) program is a better choice to GET a
resource from a web server, since it follows HTTP redirects, merges chunked
response bodies, strips-off the HTTP header, and can write the resource to a
file or to its standard output, but fetch(1) cannot PUT or POST data.  Httpf
can be used to make PUT and POST requests as well as GET requests, and always
writes the complete response to its standard output, including the HTTP
header.  The filter requires the name or address of the HTTP server to be
passed to it as the first command-line argument.  A second optional argument
may be passed specifying the remote port number, which defaults to 80.  The
filter exits when the remote process closes the connection.
.Pp
For example, if the file soap.request contained a SOAP request message,
including the HTTP header, a shell program could get the SOAP response,
including the HTTP header, from a server with:  
.Bd -literal
% httpf hostname.domain < soap.request > soap.response
.Ed
.Pp
If the user is sending an HTTP/1.1 request to a server, he or she should
include a "Connection: close" header with the request, to get the server to
terminate the connection, otherwise it will hang until the server times-out.
If the user is making multiple requests with one invocation of httpf, it is
the user's responsibility to detect the Content-Length headers of any replies
to find the boundaries between response bodies, if present.
.Sh IMPLEMENTATION NOTES
httpf prints the raw data it reads from the remote process unaltered.
Specifically, it does not handle HTTP redirects, nor does it merge chunked
HTTP responses.
.Sh RETURN VALUES
httpf returns 0 to the shell upon success and 1 upon failure.
.Sh AUTHOR
.An James Bailie Aq jimmy@jamesbailie.com
.br
http://www.jamesbailie.com
